searchNodes=[{"doc":"Ecto/Postgrex types to work with the PostgreSQL IP4R extension. Setup Define a module with the required Postgrex extensions added: Postgrex.Types . define ( MyApp.PostgrexTypes , EctoIPRange.Postgrex . extensions ( ) ++ Ecto.Adapters.Postgres . extensions ( ) ) Add this module to your Ecto repo configuration: config :my_app , MyRepo , types : MyApp.PostgrexTypes Usage Define the appropriate field type in your schema: defmodule MySchema do use Ecto.Schema schema &quot;test_schema_ip4&quot; do :my_ip_range_field , EctoIPRange.IP4 end end The following fields are currently supported: Single Addresses EctoIPRange.IP4 EctoIPRange.IP6 Address Ranges EctoIPRange.IP4R EctoIPRange.IP6R EctoIPRange.IPRange Migrations To use the fields in migrations you need to either access the underlying type atom or specify the type atom directly: defmodule MyRepo.Migration do use Ecto.Migration def change do create table ( &quot;my_table&quot; ) do add :direct , :ip4r add :underlying , EctoIPRange.IP4R . type ( ) end end end Changesets To insert a database record with an IP range field you need to ensure the internal type is properly casted. For example using a changeset: % MySchema { } |&gt; Ecto.Changeset . cast ( %{ ip4_address : &quot;1.2.3.4&quot; } , [ :ip4_address ] ) |&gt; Ecto.Changeset . validate_required ( [ :ip4_address ] ) |&gt; MyRepo . insert! ( ) Please refer to the individual types to see what values are accepted.","ref":"EctoIPRange.html","title":"EctoIPRange","type":"module"},{"doc":"Provides a simple list of available Postgrex extension modules.","ref":"EctoIPRange.Postgrex.html","title":"EctoIPRange.Postgrex","type":"module"},{"doc":"Returns all available Postgrex extension modules.","ref":"EctoIPRange.Postgrex.html#extensions/0","title":"EctoIPRange.Postgrex.extensions/0","type":"function"},{"doc":"Struct for PostgreSQL :ip4 fields. Usage When used during a changeset cast the following values are accepted: :inet.ip4_address() : an IP4 tuple, e.g. {127, 0, 0, 1} binary : binary representation, e.g. &quot;127.0.0.1&quot; EctoIPRange.IP4.t() : a pre-casted struct Fields ip","ref":"EctoIPRange.IP4.html","title":"EctoIPRange.IP4","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoIPRange.IP4.html#embed_as/1","title":"EctoIPRange.IP4.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoIPRange.IP4.html#equal?/2","title":"EctoIPRange.IP4.equal?/2","type":"function"},{"doc":"","ref":"EctoIPRange.IP4.html#t:t/0","title":"EctoIPRange.IP4.t/0","type":"type"},{"doc":"Struct for PostgreSQL :ip4r fields. Usage When used during a changeset cast the following values are accepted: :inet.ip4_address() : an IP4 tuple, e.g. {127, 0, 0, 1} (single address only) binary &quot;127.0.0.1&quot; : single address &quot;127.0.0.0/24&quot; : CIDR notation for a range from 127.0.0.0 to 127.0.0.255 &quot;127.0.0.1-127.0.0.2&quot; : arbitrary range EctoIPRange.IP4R.t() : a pre-casted struct Fields range first_ip last_ip","ref":"EctoIPRange.IP4R.html","title":"EctoIPRange.IP4R","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoIPRange.IP4R.html#embed_as/1","title":"EctoIPRange.IP4R.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoIPRange.IP4R.html#equal?/2","title":"EctoIPRange.IP4R.equal?/2","type":"function"},{"doc":"","ref":"EctoIPRange.IP4R.html#t:t/0","title":"EctoIPRange.IP4R.t/0","type":"type"},{"doc":"Struct for PostgreSQL :ip6 fields. Usage When used during a changeset cast the following values are accepted: :inet.ip6_address() : an IP6 tuple, e.g. {8193, 3512, 34211, 0, 0, 35374, 880, 29492} binary : binary representation, e.g. &quot;2001:0db8:85a3:0000:0000:8a2e:0370:7334&quot; EctoIPRange.IP6.t() : a pre-casted struct IP4 addresses (binary and tuple) will be converted to IP6 format when casted. Fields ip","ref":"EctoIPRange.IP6.html","title":"EctoIPRange.IP6","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoIPRange.IP6.html#embed_as/1","title":"EctoIPRange.IP6.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoIPRange.IP6.html#equal?/2","title":"EctoIPRange.IP6.equal?/2","type":"function"},{"doc":"","ref":"EctoIPRange.IP6.html#t:t/0","title":"EctoIPRange.IP6.t/0","type":"type"},{"doc":"Struct for PostgreSQL :ip6r fields. Usage When used during a changeset cast the following values are accepted: :inet.ip6_address() : an IP6 tuple, e.g. {8193, 3512, 34211, 0, 0, 35374, 880, 29492} (single address only) binary &quot;2001:0db8:85a3:0000:0000:8a2e:0370:7334&quot; : single address &quot;2001:0db8:85a3:0000:0000:8a2e:0370:0000/112&quot; : CIDR notation for a range from 2001:0db8:85a3:0000:0000:8a2e:0370:0000 to 2001:0db8:85a3:0000:0000:8a2e:0370:ffff &quot;2001:0db8:85a3:0000:0000:8a2e:0370:7334-2001:0db8:85a3:0000:0000:8a2e:0370:7335&quot; : arbitrary range EctoIPRange.IP4.t() : a pre-casted struct IP4 addresses (binary and tuple) will be converted to IP6 format when casted. Fields range first_ip last_ip","ref":"EctoIPRange.IP6R.html","title":"EctoIPRange.IP6R","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoIPRange.IP6R.html#embed_as/1","title":"EctoIPRange.IP6R.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoIPRange.IP6R.html#equal?/2","title":"EctoIPRange.IP6R.equal?/2","type":"function"},{"doc":"","ref":"EctoIPRange.IP6R.html#t:t/0","title":"EctoIPRange.IP6R.t/0","type":"type"},{"doc":"Struct for PostgreSQL :iprange fields. Usage When used during a changeset cast the following values are accepted: :inet.ip4_address() : an IP4 tuple, e.g. {127, 0, 0, 1} (single address only) :inet.ip6_address() : an IP6 tuple, e.g. {8193, 3512, 34211, 0, 0, 35374, 880, 29492} (single address only) binary &quot;127.0.0.1&quot; : single address &quot;127.0.0.0/24&quot; : CIDR notation for a range from 127.0.0.0 to 127.0.0.255 &quot;127.0.0.1-127.0.0.2&quot; : arbitrary range &quot;2001:0db8:85a3:0000:0000:8a2e:0370:7334&quot; : single address &quot;2001:0db8:85a3:0000:0000:8a2e:0370:0000/112&quot; : CIDR notation for a range from 2001:0db8:85a3:0000:0000:8a2e:0370:0000 to 2001:0db8:85a3:0000:0000:8a2e:0370:ffff &quot;2001:0db8:85a3:0000:0000:8a2e:0370:7334-2001:0db8:85a3:0000:0000:8a2e:0370:7335&quot; : arbitrary range EctoIPRange.IPRange.t() : a pre-casted struct Fields range first_ip last_ip","ref":"EctoIPRange.IPRange.html","title":"EctoIPRange.IPRange","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"EctoIPRange.IPRange.html#embed_as/1","title":"EctoIPRange.IPRange.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"EctoIPRange.IPRange.html#equal?/2","title":"EctoIPRange.IPRange.equal?/2","type":"function"},{"doc":"","ref":"EctoIPRange.IPRange.html#t:t/0","title":"EctoIPRange.IPRange.t/0","type":"type"},{"doc":"Postgrex extension for &quot;ip4&quot; fields.","ref":"EctoIPRange.Postgrex.IP4Extension.html","title":"EctoIPRange.Postgrex.IP4Extension","type":"module"},{"doc":"Callback implementation for Postgrex.Extension.decode/1 .","ref":"EctoIPRange.Postgrex.IP4Extension.html#decode/1","title":"EctoIPRange.Postgrex.IP4Extension.decode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.encode/1 .","ref":"EctoIPRange.Postgrex.IP4Extension.html#encode/1","title":"EctoIPRange.Postgrex.IP4Extension.encode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.format/1 .","ref":"EctoIPRange.Postgrex.IP4Extension.html#format/1","title":"EctoIPRange.Postgrex.IP4Extension.format/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.init/1 .","ref":"EctoIPRange.Postgrex.IP4Extension.html#init/1","title":"EctoIPRange.Postgrex.IP4Extension.init/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.matching/1 .","ref":"EctoIPRange.Postgrex.IP4Extension.html#matching/1","title":"EctoIPRange.Postgrex.IP4Extension.matching/1","type":"function"},{"doc":"Postgrex extension for &quot;ip4r&quot; fields.","ref":"EctoIPRange.Postgrex.IP4RExtension.html","title":"EctoIPRange.Postgrex.IP4RExtension","type":"module"},{"doc":"Callback implementation for Postgrex.Extension.decode/1 .","ref":"EctoIPRange.Postgrex.IP4RExtension.html#decode/1","title":"EctoIPRange.Postgrex.IP4RExtension.decode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.encode/1 .","ref":"EctoIPRange.Postgrex.IP4RExtension.html#encode/1","title":"EctoIPRange.Postgrex.IP4RExtension.encode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.format/1 .","ref":"EctoIPRange.Postgrex.IP4RExtension.html#format/1","title":"EctoIPRange.Postgrex.IP4RExtension.format/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.init/1 .","ref":"EctoIPRange.Postgrex.IP4RExtension.html#init/1","title":"EctoIPRange.Postgrex.IP4RExtension.init/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.matching/1 .","ref":"EctoIPRange.Postgrex.IP4RExtension.html#matching/1","title":"EctoIPRange.Postgrex.IP4RExtension.matching/1","type":"function"},{"doc":"Postgrex extension for &quot;ip6&quot; fields.","ref":"EctoIPRange.Postgrex.IP6Extension.html","title":"EctoIPRange.Postgrex.IP6Extension","type":"module"},{"doc":"Callback implementation for Postgrex.Extension.decode/1 .","ref":"EctoIPRange.Postgrex.IP6Extension.html#decode/1","title":"EctoIPRange.Postgrex.IP6Extension.decode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.encode/1 .","ref":"EctoIPRange.Postgrex.IP6Extension.html#encode/1","title":"EctoIPRange.Postgrex.IP6Extension.encode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.format/1 .","ref":"EctoIPRange.Postgrex.IP6Extension.html#format/1","title":"EctoIPRange.Postgrex.IP6Extension.format/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.init/1 .","ref":"EctoIPRange.Postgrex.IP6Extension.html#init/1","title":"EctoIPRange.Postgrex.IP6Extension.init/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.matching/1 .","ref":"EctoIPRange.Postgrex.IP6Extension.html#matching/1","title":"EctoIPRange.Postgrex.IP6Extension.matching/1","type":"function"},{"doc":"Postgrex extension for &quot;ip6r&quot; fields.","ref":"EctoIPRange.Postgrex.IP6RExtension.html","title":"EctoIPRange.Postgrex.IP6RExtension","type":"module"},{"doc":"Callback implementation for Postgrex.Extension.decode/1 .","ref":"EctoIPRange.Postgrex.IP6RExtension.html#decode/1","title":"EctoIPRange.Postgrex.IP6RExtension.decode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.encode/1 .","ref":"EctoIPRange.Postgrex.IP6RExtension.html#encode/1","title":"EctoIPRange.Postgrex.IP6RExtension.encode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.format/1 .","ref":"EctoIPRange.Postgrex.IP6RExtension.html#format/1","title":"EctoIPRange.Postgrex.IP6RExtension.format/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.init/1 .","ref":"EctoIPRange.Postgrex.IP6RExtension.html#init/1","title":"EctoIPRange.Postgrex.IP6RExtension.init/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.matching/1 .","ref":"EctoIPRange.Postgrex.IP6RExtension.html#matching/1","title":"EctoIPRange.Postgrex.IP6RExtension.matching/1","type":"function"},{"doc":"Postgrex extension for &quot;iprange&quot; fields.","ref":"EctoIPRange.Postgrex.IPRangeExtension.html","title":"EctoIPRange.Postgrex.IPRangeExtension","type":"module"},{"doc":"Callback implementation for Postgrex.Extension.decode/1 .","ref":"EctoIPRange.Postgrex.IPRangeExtension.html#decode/1","title":"EctoIPRange.Postgrex.IPRangeExtension.decode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.encode/1 .","ref":"EctoIPRange.Postgrex.IPRangeExtension.html#encode/1","title":"EctoIPRange.Postgrex.IPRangeExtension.encode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.format/1 .","ref":"EctoIPRange.Postgrex.IPRangeExtension.html#format/1","title":"EctoIPRange.Postgrex.IPRangeExtension.format/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.init/1 .","ref":"EctoIPRange.Postgrex.IPRangeExtension.html#init/1","title":"EctoIPRange.Postgrex.IPRangeExtension.init/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.matching/1 .","ref":"EctoIPRange.Postgrex.IPRangeExtension.html#matching/1","title":"EctoIPRange.Postgrex.IPRangeExtension.matching/1","type":"function"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Enhancements IPv6 text representations are converted to lowercase hex digits to better match output from the :inet module and closer follow RFC 5952 Support for &quot;iprange&quot; fields added ( #1 ) Backwards incompatible changes Minimum required Elixir version is now ~&gt; 1.9","ref":"changelog.html#v0-2-0-2022-01-29","title":"Changelog - v0.2.0 (2022-01-29)","type":"extras"},{"doc":"Initial Release","ref":"changelog.html#v0-1-0-2020-02-29","title":"Changelog - v0.1.0 (2020-02-29)","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"Ecto/Postgrex types to work with the PostgreSQL IP4R extension.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add the library as a dependency to your mix.exs file: defp deps do [ # ... { :ecto_ip_range , &quot;~&gt; 0.2.0&quot; } , # ... ] end","ref":"readme.html#setup","title":"Overview - Setup","type":"extras"},{"doc":"Apache License, Version 2.0","ref":"readme.html#license","title":"Overview - License","type":"extras"}]